-- Filename:     tb_johnson_counter.vhd
-- Filetype:     VHDL Testbench
-- Date:         19 feb 2015
-- Update:       -
-- Description:  VHDL Testbench for simulation
-- Author:       J. op den Brouw
-- State:        Demo
-- Error:        -
-- Version:      1.0
-- Copyright:    (c)2015, De Haagse Hogeschool

-- This file contains a VHDL testbench for a Johnson counter.

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity tb_johnson_counter is
end entity tb_johnson_counter;

architecture sim of tb_johnson_counter is
-- The complete hardware
component johnson_counter is
    port (clk :    in std_logic;
          areset : in std_logic;
			 count :  out std_logic_vector (4 downto 0);
			 tc :     out std_logic
	      );
end component johnson_counter;

-- A small delay
constant small_delay : time := 1 ns;

-- Signals to be traced, from the hardware
signal clk : std_logic;
signal areset : std_logic;
signal count : std_logic_vector (4 downto 0);
signal tc : std_logic;

begin

	dut: johnson_counter
	port map (clk => clk, areset => areset, count => count, tc => tc);

	-- The Clock Generation Process.
	clockgen: process is
	begin
      clk <= '1';
		wait for 50 ns;
		clk <= '0';
		wait for 50 ns;
	end process;

	datagen: process is
	begin
		areset <= '1';
		wait for 75 ns;
		areset <= '0';
		wait;
	end process;
	
end architecture sim;